Signed-off-by: Koen De Wit <koen.de.wit@xxxxxxxxxx>
---
298 | 82
+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
298.out | 19 ++++++++++++++
2 files changed, 101 insertions(+), 0 deletions(-)
create mode 100644 298
create mode 100644 298.out
diff --git a/298 b/298
new file mode 100644
index 0000000..47ac55d
--- /dev/null
+++ b/298
@@ -0,0 +1,82 @@
+#! /bin/bash
+# FS QA Test No. 298
+#
+# Tests file clone functionality of btrfs ("reflinks") on directory trees.
+# - Create directory and subdirectory, each having one file
+# - Create 2 reflinked copies of the tree
+# - Modify the original files
+# - Modify one of the copies
+#
+#-----------------------------------------------------------------------
+# Copyright (c) 2013, Oracle and/or its affiliates. All Rights Reserved.
+#
+# This program is free software; you can redistribute it and/or
+# modify it under the terms of the GNU General Public License as
+# published by the Free Software Foundation.
+#
+# This program is distributed in the hope that it would be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
+# GNU General Public License for more details.
+#
+# You should have received a copy of the GNU General Public License
+# along with this program; if not, write the Free Software Foundation,
+# Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA
+#-----------------------------------------------------------------------
+#
+# creator
+owner=koen.de.wit@xxxxxxxxxx
+
+seq=`basename $0`
+echo "QA output created by $seq"
+
+here=`pwd`
+tmp=/tmp/$$
+status=1 # failure is the default!
+trap "_cleanup; exit \$status" 0 1 2 3 15
+
+_cleanup()
+{
+ cd /
+ rm -f $tmp.*
+}
+
+# get standard environment, filters and checks
+. ./common.rc
+. ./common.filter
+
+# real QA test starts here
+_supported_fs btrfs
+_supported_os Linux
+
+_require_cp_reflink
+
+TESTDIR1=$TEST_DIR/test-$seq.$$
+mkdir $TESTDIR1
+
+_catfiles() {
+ for F in original/file1 original/subdir/file2 \
+ copy1/file1 copy1/subdir/file2 \
+ copy2/file1 copy2/subdir/file2
+ do
+ md5sum $TESTDIR1/$F | $AWK_PROG 'END {print $1}'
+ done
+}
+
+mkdir $TESTDIR1/original
+mkdir $TESTDIR1/original/subdir
+$XFS_IO_PROG -f -c 'pwrite -S 0x61 0 9000' $TESTDIR1/original/file1 >
/dev/null
+$XFS_IO_PROG -f -c 'pwrite -S 0x62 0 11000'
$TESTDIR1/original/subdir/file2 > /dev/null
+cp --recursive --reflink $TESTDIR1/original $TESTDIR1/copy1
+cp --recursive --reflink $TESTDIR1/copy1 $TESTDIR1/copy2
+_catfiles
+$XFS_IO_PROG -c 'pwrite -S 0x63 0 13000' $TESTDIR1/original/file1 >
/dev/null
+$XFS_IO_PROG -c 'pwrite -S 0x64 5000 1000'
$TESTDIR1/original/subdir/file2 > /dev/null
+_catfiles
+$XFS_IO_PROG -c 'pwrite -S 0x65 0 9000' $TESTDIR1/copy1/file1 > /dev/null
+$XFS_IO_PROG -c 'pwrite -S 0x66 5000 25000'
$TESTDIR1/copy1/subdir/file2 > /dev/null
+_catfiles
+
+# success, all done
+status=0
+exit
diff --git a/298.out b/298.out
new file mode 100644
index 0000000..f8b6b70
--- /dev/null
+++ b/298.out
@@ -0,0 +1,19 @@
+QA output created by 298
+42d69d1a6d333a7ebdf64792a555e392
+ca390545f0aedb54b808d6128c56a7dd
+42d69d1a6d333a7ebdf64792a555e392
+ca390545f0aedb54b808d6128c56a7dd
+42d69d1a6d333a7ebdf64792a555e392
+ca390545f0aedb54b808d6128c56a7dd
+260f6785c0537fd12582dcae28a3c1a9
+b8d91fb600f6f2191f2ba66665374860
+42d69d1a6d333a7ebdf64792a555e392
+ca390545f0aedb54b808d6128c56a7dd
+42d69d1a6d333a7ebdf64792a555e392
+ca390545f0aedb54b808d6128c56a7dd
+260f6785c0537fd12582dcae28a3c1a9
+b8d91fb600f6f2191f2ba66665374860
+b20229a003e3985c4b0e6806abcd6642
+b815b24069db14e0a3a07169fd563e93
+42d69d1a6d333a7ebdf64792a555e392
+ca390545f0aedb54b808d6128c56a7dd
--
1.7.2.5
_______________________________________________
xfs mailing list
xfs@xxxxxxxxxxx
http://oss.sgi.com/mailman/listinfo/xfs